<?php
class ControllerPaymentPaykeeper extends Controller {
	public function index() {
		$data['button_confirm'] = $this->language->get('button_confirm');

		$this->load->model('checkout/order');

		$order_info = $this->model_checkout_order->getOrder($this->session->data['order_id']);

        $payment_parameters = http_build_query(array(
            "orderid"=>$this->session->data['order_id'],
            "clientid"=>$order_info['email'],
            "sum"=>$this->currency->format($order_info['total'], $order_info['currency_code'], $order_info['currency_value'], false),
            "phone"=>$order_info['telephone']
        ));

        $data['server'] = $this->config->get('paykeeperserver');
        $data['payment_parameters'] = $payment_parameters;

		if (file_exists(DIR_TEMPLATE . $this->config->get('config_template') . '/template/payment/paykeeper.tpl')) {
			return $this->load->view($this->config->get('config_template') . '/template/payment/paykeeper.tpl', $data);
		} else {
			return $this->load->view('default/template/payment/paykeeper.tpl', $data);
		}
	}
	public function callback() {

		if ($this->request->server['REQUEST_METHOD'] == 'POST') {
			$this->load->model('checkout/order');
			
			if(isset($this->request->post['id']) && isset($this->request->post['orderid'])){
				$secret_seed = $this->config->get('paykeepersecret');
				$id = $this->request->post['id'];
				$sum = $this->request->post['sum'];
				$clientid = $this->request->post['clientid'];
				$orderid = $this->request->post['orderid'];
				$key = $this->request->post['key'];

				if ($key != md5 ($id . sprintf ("%.2lf", $sum).$clientid.$orderid.$secret_seed))
				{
					echo "Error! Hash mismatch";
					exit;
				}
				
				$order_info = $this->model_checkout_order->getOrder($orderid);
				
				if ($orderid == "")
				{
                    echo "Empty order!";
				}
				else
				{
					$this->model_checkout_order->addOrderHistory($orderid, $this->config->get('paykeeper_order_status_id'));
				}
				echo "OK ".md5($id.$secret_seed);
			}
			else echo "OK";
		}
	}
	
	public function gopay() {
		
		$this->load->language('checkout/checkout');
		$this->load->language('payment/paykeeper');
		
		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/home')
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_cart'),
			'href' => $this->url->link('checkout/cart')
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->url->link('checkout/checkout', '', 'SSL')
		);
		
		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('paykeeper_title'),
			'href' => $this->url->link('payment/paykeeper/gopay', '', 'SSL')
		);
		$data['heading_title'] = $this->language->get('paykeeper_title');
		$this->document->setTitle($data['heading_title']);
		
		$this->load->model('checkout/order');
		
		$order_info = $this->model_checkout_order->getOrder($this->session->data['order_id']);

		//$payment_parameters = http_build_query(array(
			//"orderid"=>$this->session->data['order_id'],
			//"clientid"=>$order_info['email'],
			//"sum"=>$this->currency->format($order_info['total'], $order_info['currency_code'], $order_info['currency_value'], false),
			//"phone"=>$order_info['telephone']
		//));
		
		//$options = array("http"=>array(
			//"method"=>"POST",
			//"header"=>"Content-type: application/x-www-form-urlencoded",
			//"content"=>$payment_parameters
		//));
		//$data['options'] = $options;

		$data['server'] = $this->config->get('paykeeperserver');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['column_right'] = $this->load->controller('common/column_right');
		$data['content_top'] = $this->load->controller('common/content_top');
		$data['content_bottom'] = $this->load->controller('common/content_bottom');
		$data['footer'] = $this->load->controller('common/footer');
		$data['header'] = $this->load->controller('common/header');
		
        //CREATE METHOD
        $data['obj'] = $this;

        $data['sum'] = $this->currency->format($order_info['total'], $order_info['currency_code'], $order_info['currency_value'], false);
        $data['orderid'] = $this->session->data['order_id'];
        $data['clientid'] = $this->session->data['payment_address']['firstname'] . " " . $this->session->data['payment_address']['lastname'];
        $data['client_email'] = $order_info['email'];
        $data['client_phone'] = $order_info['telephone'];
        $data['service_name'] = "";
		$data['secret'] = $this->config->get('paykeepersecret');

        $to_hash = number_format ($data['sum'], 2 , '.' , '') .
                                  $data['clientid']           . 
                                  $data['orderid']            .   
                                  $data['service_name']       .   
                                  $data['client_email']       .   
                                  $data['client_phone']       .   
                                  $data['secret'];

        $data['sign'] = hash ('sha256' , $to_hash);
		
		if (file_exists(DIR_TEMPLATE . $this->config->get('config_template') . '/template/payment/paykeeper_iframe.tpl')) {
			$this->response->setOutput($this->load->view($this->config->get('config_template') . '/template/payment/paykeeper_iframe.tpl', $data));
		} else {
			$this->response->setOutput($this->load->view('default/template/payment/paykeeper_iframe.tpl', $data));
		}
	}
	public function success() {
		
		$this->load->language('checkout/checkout');
		$this->load->language('payment/paykeeper');
		
		$data['heading_title'] = $this->language->get('paykeeper_title');
		
		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/home')
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_cart'),
			'href' => $this->url->link('checkout/cart')
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->url->link('checkout/checkout', '', 'SSL')
		);
		
		$data['message'] = $this->language->get('paykeeper_success');

		$this->document->setTitle($data['message']);
		
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['column_right'] = $this->load->controller('common/column_right');
		$data['content_top'] = $this->load->controller('common/content_top');
		$data['content_bottom'] = $this->load->controller('common/content_bottom');
		$data['footer'] = $this->load->controller('common/footer');
		$data['header'] = $this->load->controller('common/header');
		
		if (file_exists(DIR_TEMPLATE . $this->config->get('config_template') . '/template/payment/paykeeper_feedback.tpl')) {
			$this->response->setOutput($this->load->view($this->config->get('config_template') . '/template/payment/paykeeper_feedback.tpl', $data));
		} else {
			$this->response->setOutput($this->load->view('default/template/payment/paykeeper_feedback.tpl', $data));
		}
	}
	public function failed() {
		
		$this->load->language('checkout/checkout');
		$this->load->language('payment/paykeeper');
		
		$data['heading_title'] = $this->language->get('paykeeper_title');
		
		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/home')
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_cart'),
			'href' => $this->url->link('checkout/cart')
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->url->link('checkout/checkout', '', 'SSL')
		);
		
		$data['message'] = $this->language->get('paykeeper_failed');

		$this->document->setTitle($data['message']);
		
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['column_right'] = $this->load->controller('common/column_right');
		$data['content_top'] = $this->load->controller('common/content_top');
		$data['content_bottom'] = $this->load->controller('common/content_bottom');
		$data['footer'] = $this->load->controller('common/footer');
		$data['header'] = $this->load->controller('common/header');
		
		if (file_exists(DIR_TEMPLATE . $this->config->get('config_template') . '/template/payment/paykeeper_feedback.tpl')) {
			$this->response->setOutput($this->load->view($this->config->get('config_template') . '/template/payment/paykeeper_feedback.tpl', $data));
		} else {
			$this->response->setOutput($this->load->view('default/template/payment/paykeeper_feedback.tpl', $data));
		}
	}

    public function confirm() {
        $this->load->model('checkout/order');
        $this->model_checkout_order->addOrderHistory($this->session->data['order_id'], 1);
    }
}
